#ifndef __ASM_MOO__
#define __ASM_MOO__

#include <inc/adb.h>

extern void ASM_init (void);
extern long ASM_vm86 (int, volatile void *);
extern void ASM_reload_stack (ui esp, us ss);
extern void ASM_restore_fs_gs (void);
extern int  ASM_is_segment_big (us selector);
extern void ASM_simulate_irq (ui off, us sel, ui esp, us ss, ui fs, ui gs);
extern void ASM_invoke_callback (ui rm_stack_off, us rm_stack_sel,
                                 ui *data_off, us *data_sel,
                                 ui stack_off, us stack_sel,
                                 ui proc_off, us proc_sel);

extern ub ASM_int_trampoline[];
extern us ASM_cs;
extern us ASM_es;
extern us ASM_ss;
extern us ASM_ds;
extern us ASM_fs;
extern us ASM_gs;
extern ui ASM_int_trampoline_nint;
extern ui ASM_int_trampoline_addr;
extern ub ASM_int_trampoline_end[];
extern ui ASM_vbe_pm_interface_tab[];
extern ui ASM_stack_top;
extern ui ASM_stack_chunk_size;

extern ub ASM_int10_redirector[];
extern ub ASM_int10_redirector_end[];
extern us ASM_bios_int10_handler[];
extern ub ASM_vm86_ret[];

#endif /* __ASM_MOO__ */
