#ifndef __DMA_MOO__
#define __DMA_MOO__

#include <inc/adb.h>

typedef int (*DMA_read_handler) (ui addr, int size, int *irq);
typedef int (*DMA_misc_handler) (int);

extern void DMA_init (void);
extern void DMA_run (void);
extern void DMA_hold_DREQ (int nchan);
extern void DMA_release_DREQ (int nchan);
extern int  DMA_get_channel_mode (int nchan);
extern void DMA_register_channel (int nchan,
                                  DMA_read_handler read_handler,
                                  DMA_misc_handler misc_handler);

#endif /* __DMA_MOO__ */
