#ifndef __SEL_MOO__
#define __SEL_MOO__

#include <inc/adb.h>

extern us SEL_get_user_code (void);
extern us SEL_get_user_data (void);
extern unsigned long SEL_linear_addr (int selector, ui off);
extern unsigned long SEL_get_selector_base (int selector);
extern unsigned int SEL_get_selector_limit (int selector);
extern int SEL_is_system_selector (int selector);
extern void SEL_init (void);

#define IS_GDT_SELECTOR(x) (0==(x&4))
#define SELLIN(sel, off) SEL_linear_addr (sel, off)
#define SEGLIN(seg, off) ((((ui)seg)*16)+(((ui)off)&0xffff))

#endif /* __SEL_MOO__ */
