let remove_head_ws n line =
  let len = String.length line in
  let fits =
    if len > n then
      let rec f i =
	if i = n then true
	else if line.[i] = ' ' then f (succ i) else false
      in f 0
    else false
  in
  if fits then String.sub line n (len - n) else line

let subst line =
  List.fold_left begin fun line (re, subst) ->
    Str.global_replace re subst line
  end  line

let sub_foldi fold first count init arr =
  let last = first + count in
  let rec f accu i =
    if i = last then accu else
    let accu = fold i accu in
    f accu (succ i)
  in
  f init first
