#ifndef __TID_MOO__
#define __TID_MOO__

#include <inc/adb.h>

#define TID_USEC 1000000
#define TID_NSEC 1000000000

struct TID_tm {
  ul nsec;
  int sec;
  int min;
  int hour;
  int mday;
  int wday;
  int mon;
  int year;
};

extern void TID_init (void);
extern ul TID_get_abs_nsec (void);
extern ul TID_get_nsec_diff (ul ref);
extern void TID_get_tm (struct TID_tm *tm);
extern void TID_pause (void);
extern void TID_resume (void);

#endif /* __TID_MOO__ */
